/*
This is an implementation of one of the first cellular automata systems that have 
been running on Computer Systems and made the idea of cellular automata popular
John Horton Conway and colleagues at the University of Cambridge developed the
rules in 1968 after a long search for balanced rules.
For me its the first try on implementing a cellular automata system and I choose it
to have an easy start - the developed platform will hopefully be able to support my
further tries in this area.
You may use and change this sourcecoude as you wish.
Johannes Knabe (knabe@panmental.de)
Trondheim, Norway, 21.09.2003 (09/21/03)
Source website: http://life.panmental.de
*/
import java.awt.*;
import java.awt.event.*;
import java.applet.Applet; 

public class life extends Applet { 

public int initSize=40;
public int initBorderStyle=0;
public timer globaltime;

public life(){
}

public String getAppletInfo()
{
return "J.H. Conway, Game of Life - Author J.Knabe, jknabe@panmental.de - 09.2003 - Source available at http://life.panmental.de";
}


public void start(){
}

public void init() { 
globaltime=new timer();
universe earth=new universe(initSize,initBorderStyle,globaltime);
globaltime.earth=earth;
god pope =new god(earth,globaltime);
GridBagLayout gridbag = new GridBagLayout();

    GridBagConstraints c2 = new GridBagConstraints();
    c2.anchor=GridBagConstraints.CENTER;
    c2.fill=GridBagConstraints.BOTH;
    c2.ipadx=1;
    c2.weightx =1;
    c2.weighty =1;
    c2.gridheight =GridBagConstraints.REMAINDER;
    gridbag.setConstraints(earth, c2);

    GridBagConstraints c3 = new GridBagConstraints();
    c3.anchor=GridBagConstraints.NORTHEAST;
    c3.ipadx=0;
    gridbag.setConstraints(globaltime, c3);

    GridBagConstraints c1 = new GridBagConstraints();
    c1.anchor=GridBagConstraints.NORTHEAST;
    c1.ipadx=0;
    c1.gridwidth =GridBagConstraints.REMAINDER;
    gridbag.setConstraints(pope, c1);

setLayout(gridbag);
add(earth); 
add(globaltime);
add(pope); 
} 

public static void main(String[] argv){
new AppletFrame("J.H. Conways' game of life",new life(),800,600);
}

}

class AppletFrame extends Frame {

private life display;

AppletFrame(String title, life applet, int width, int height){
  super(title);
  display=applet;
  applet.init();
  applet.setVisible(true);
  this.add(applet);
  this.pack();
  this.setSize(width,height);
  this.show();
  addWindowListener(
      new WindowAdapter() {  // close the window when the user clicks its close box
          public void windowClosing(WindowEvent evt) {
          close();
          }
      });
}

public void close(){
   if(display.globaltime.actiontimer.isRunning())
      display.globaltime.actiontimer.stop();
   dispose();
   }

}